/* ChkSize,  Version 1.00 for OS/2 */

/* Initialize RexxUtil */
if RxFuncQuery( "SysLoadFuncs" ) <> 0 then do
	call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
	call SysLoadFuncs
end

/* Read command line parameters */
parse upper arg commandline
/* Check parameters' validity */
parse value commandline with '"'filespec'"' cmpsize dummy
if filespec = "" then parse value commandline with filespec cmpsize dummy
/* Check for the correct number of parameters */
if dummy  <> "" then call Syntax
if cmpsize = "" then call Syntax
/* Second parameter should be a whole number */
if datatype( cmpsize, "W" ) <> 1 then call Syntax
/* Check if specified file exists */
call SysFileTree filespec, "files.", "F"
/* If it doesn't exist, or if wildcards were used, */
/* or if a directory was specified, display help   */
if files.0 <> 1 then call Syntax
parse upper value files.1 with . . actsize . file
file = strip( file )
if filespec( "N", file ) <> filespec( "N", filespec ) then call Syntax

/* Compare actual and specified file size */
select
	when actsize = cmpsize then do
		say "Sizes match exactly"
		errorlevel = 0
	end
	when actsize > cmpsize then do
		say "Actual file size exceeds specified size"
		errorlevel = 1
	end
	when actsize < cmpsize then do
		say "Actual file size less than specified file size"
		errorlevel = 2
	end
	otherwise errorlevel = 3
end
EXIT errorlevel


Syntax: procedure
	call lineout "CON", ""
	call lineout "CON", "ChkSize,  Version 1.00 for OS/2"
	call lineout "CON", "Checks if file size matches specified file"
	call lineout "CON", "size and returns an errorlevel accordingly"
	call lineout "CON", ""
	call lineout "CON", "Written by Rob van der Woude"
	call lineout "CON", "http://www.robvanderwoude.com"
	call lineout "CON", ""
	call lineout "CON", "Usage   :  CHKSIZE  <filespec>  <minimum_size>"
	call lineout "CON", ""
	call lineout "CON", "Returns :  Errorlevel 1 if greater than specified file size"
	call lineout "CON", "           Errorlevel 0 if equal to specified file size"
	call lineout "CON", "           Errorlevel 2 if smaller than specified file size"
	call lineout "CON", "           Errorlevel 3 if invalid parameters were specified"
	call lineout "CON", ""
	call lineout "CON", "Do not use wildcards in <filespec>"
	call lineout "CON", "<filespec> must be enclosed in double quotes if it contains spaces"
	EXIT 3
return
